# Kanister Governance

This document defines the governance policies of Kanister.

## Contributors

Anyone can contribute to Kanister, whether through code, design discussions,
documentation, blog posts, talks, or other means. All contributors are expected
to follow the Kanister [Code of Conduct](CODE_OF_CONDUCT.md).

Contributions to the code base, documentation, or other components in the
Kanister GitHub organization must follow the guidelines described in the
[CONTRIBUTING.md](CONTRIBUTING.md) document. Whether these contributions get
merged into the project is the prerogative of the maintainers.

## Maintainers

Maintainers are responsible for the overall security, quality and integrity of
the project. They propose, manage, review, approve/reject major change and
enhancement requests. They also have the ability to merge code into the project.
See the [MAINTAINERS.md](MAINTAINERS.md) document for the full list of
maintainer responsibilities.

Ideally, all project decisions are resolved by maintainer consensus. If this
is not possible, maintainers may call for a vote. The voting process is a simple
majority in which each maintainer receives one vote.

If a maintainer is no longer interested in or cannot perform the duties listed
above, they should move themselves to emeritus status. This can also occur by a
vote of the maintainers.

### Becoming A Maintainer

Anyone can become a Kanister maintainer. Maintainers should be extremely
proficient in Go; have relevant domain expertise; have the time and ability to
meet the maintainer expectations outlined above, and demonstrate the ability to
work with the existing maintainers and project process.

To become a maintainer, start by expressing interest to existing maintainers.
Existing maintainers will then ask you to demonstrate the qualifications
above by contributing PRs, doing code reviews, and other such tasks under
their guidance. After several months of working together, maintainers will
decide whether to grant maintainer status.

## Updating The Governance

This governance is a living document and its policies will need to be updated
over time to meet the community's needs. Until the steering committee is set
up, the maintainers will have full ownership of this governance. Changes can be
proposed at any time, but a super majority is required to approve any updates.
