# Overview

This document provides information on who the Kanister maintainers are, and
their responsibilities. If you're interested in contributing, see the
[CONTRIBUTING](CONTRIBUTING.md) guide.

## Maintainers

These are the current Kanister maintainers:

* Tom Manville @tdmanv
* Pavan Navarathna @pavannd1
* Prasad Ghangal @PrasadG193
* Vivek Singh @viveksinghggits

## Maintainer Responsibilities

Maintainers are active and visible members of the community. They have a lot of
experience with the project and are expected to have the knowledge and
insight to lead its growth and improvement.

This section describes their responsibilities.

### Uphold Code of Conduct

Uphold the values and behavior set forward by the
[Code of Conduct](CODE_OF_CONDUCT.md) to ensure a safe and welcoming community.

### Prioritize Security

Prioritize reported security vulnerabilities and ensure that they are addressed
before features or bugs. See the project's [security policy](SECURITY.md).

### Review Pull Requests

Review pull requests regularly with comments, suggestions, decision to reject,
merge or close them. Accept only high quality pull requests. Provide code
reviews and guidance on incoming pull requests to adhere to established
standards, best practices and guidelines.

### Triage Open Issues

Review issues regularly to determine their priority and relevance, with proper
labeling to identify milestones, blockers, complexity, entry-level issues etc.

### Be Responsive

Respond to Slack messages, enhancement requests, and forum posts. Allocate time
to reviewing and commenting on issues and conversations as they come in.

### Maintain Overall System Quality

Maintain healthy test coverage and code quality report score. Avoid dependency
bloat. Mitigate breaking changes.

### Manage Releases

Make frequent project releases to the community. Keep the release branch at
production quality at all times. Backport features as needed. Cut release
branches and tags to enable future patches.

### Attend Community Meetings

Regularly promote and attend the recurring Kanister community meetings.
